package Sipwise::NGCP::Config::CLI::Main::Configure::Config;

use 5.010;
use strict;
use warnings;
use vars qw(@ISA);
use Sipwise::NGCP::Config::CLI::Main::Configure;
@ISA = ("Sipwise::NGCP::Config::CLI::Main::Configure");

use YAML::Tiny;
use Data::Dumper;

sub new {
	my $class = shift;
	my $cmdstr = shift;
	my $config = shift || '/etc/ngcp-config/config.yml';

	my $self = {};
	bless($self, $class);

	$self->{last} = 1;
	$self->{show_subcommands} = 0;
	$self->{commands} = {};
	$self->{config} = $config;
	$self->{yaml} = YAML::Tiny->read($self->{config});
	unless($self->{yaml}) {
		print "Failed to open config file: $YAML::Tiny::errstr\n";
		return undef;
	}
	#print Dumper $yaml->[0];
	if(defined $cmdstr) {
		my $seps = $cmdstr =~ tr/\.//;
		$self->int_add_commands($self->{yaml}->[0], "", $seps);
	}
	return $self;
}


sub run {
	my $self = shift;
	my $key = shift;
	my $val = join ' ', @_;

	$key = "" unless(defined $key);
	$key =~ s/^\s*//;
	$key =~ s/\s*$//;
	return $self unless(length $key);

	$val = "" unless(defined $val);
	$val  =~ s/^\s*//;
	$val =~ s/\s*$//;

	unless(length $val) {
		return $self->get($key);
	} else {
		return $self->set($key, $val);
	}
}

1;
