package Sipwise::NGCP::Config::CLI::Main::Configure::Show;

use 5.010;
use strict;
use warnings;
use vars qw(@ISA);
use Sipwise::NGCP::Config::CLI::Main;
@ISA = ("Sipwise::NGCP::Config::CLI::Main");

use YAML::Tiny;
use Data::Dumper;

sub new {
	my $class = shift;
	my $cmdstr = shift;

	my $self = {};
	bless($self, $class);

	$self->{commands} = {};
	return $self;
}

sub iterate {
	my $self = shift;
	my $yaml = shift;
	my $name = shift;

	if(!defined $yaml) {
	  # there seem to be strange values sometimes, like:
	  # dos_whitelisted_ips: ~
	}
	elsif(ref $yaml eq 'HASH') {
		foreach my $k(keys %{$yaml}) {
			$self->iterate($yaml->{$k}, $name.".".$k);
		}
	} elsif(ref $yaml eq 'ARRAY') {
		for(my $i = 0; $i < @{$yaml}; ++$i) {
			$self->iterate($yaml->[$i], $name.".".$i);
		}
	} elsif(ref $yaml eq '') {
		$name =~ s/^\.//;
		print "  ".$name." ".$yaml."\n";
	} else {
		# silently ignore other types
	}
}

sub print {
	my $self = shift;
	my $name = shift;
	my $file = shift;

	# re-read config in each run, in case someone has
	# changed it in the meanwhle
	my $yaml = YAML::Tiny->read($file);
	unless($yaml) {
		print "Failed to open config file: $YAML::Tiny::errstr\n";
		return undef;
	}

	$yaml = $yaml->[0];
	print $name, "\n";
	$self->iterate($yaml, "");
	print "exit\n\n";

	return 1;
}

sub run {
	my $self = shift;

	my $files = { 
		'config' => '/etc/ngcp-config/config.yml',
		'constants' => '/etc/ngcp-config/constants.yml',
	};
	foreach my $k(keys %{$files}) {
		$self->print($k, $files->{$k});
	}
	return $self->get_parent();
}

1;
